# Leveraging RGB-D Data with Cross-Modal Context Mining for Glass Surface Detection
This is the code for Leveraging RGB-D Data with Cross-Modal Context Mining for Glass Surface Detection, which is presented in AAAI 2025. Visit our project homepage for any updates. (https://jiaying.link/AAAI25-RGBDGlass/)

Network weight and visual results can be found in this [link](https://portland-my.sharepoint.com/:f:/g/personal/jiayinlin5-c_my_cityu_edu_hk/Eub6js3tpu9OpBLZQ1fLha0BLkkRXuNgPO_ohSESvqOzNA?e=UNwBBV).


## Test and Evaluate
  
Modify the dataset path defined in `best_predict.py`. Download `best.pth` from the above link and then run `best_predict.py`. Run `evaluation/eval_depth.py` to evaluate the performance. You can also download the inference results `our_best_results.zip` from the above link.

## Train 

run `python train_depth.py` to train the model from scratch.

## Contact
jiayinlin5-c@my.cityu.edu.hk

Please cite our paper if you use our code or fine-tuned weight:

```bibtex
@inproceedings{aaai2025_rgbdglass,
  title={Leveraging RGB-D Data with Cross-Modal Context Mining for Glass Surface Detection},
  author={Lin, Jiaying and Yeung, Yuen Hei and Ye, Shuquan and Lau, Rynson WH},
  booktitle={Proc. AAAI},
  year={2025}
}
```

## License
```
Leveraging RGB-D Data with Cross-Modal Context Mining for Glass Surface Detection
Jiaying Lin, Yuen Hei Yeung, Shuquan Ye, and Rynson W.H. Lau

The code is licensed under a BSD 3-clause License. For non-commercial purposes only.
Please cite our paper, if you use our code:

@inproceedings{aaai2025_rgbdglass,
  title={Leveraging RGB-D Data with Cross-Modal Context Mining for Glass Surface Detection},
  author={Lin, Jiaying and Yeung, Yuen Hei and Ye, Shuquan and Lau, Rynson WH},
  booktitle={Proc. AAAI},
  year={2025}
}

Copyright (c) 2024
All rights reserved by Jiaying Lin, Yuen Hei Yeung, Shuquan Ye, and Rynson W.H. Lau
Department of Computer Science, City University of Hong Kong, Hong Kong

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its
   contributors may be used to endorse or promote products derived from
   this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
```